#include <iostream>
#include <iomanip>
#include <cstdlib>

#include "mpi.h"
#define NO_DATA 2
using namespace std;

int main(int argc, char **argv) 
{
	int rank, size;
	int *data=NULL, sum;
	int localDat[NO_DATA];
	int *dat1=NULL;
	int i;
	
	// Initialization
	MPI_Init(&argc, &argv);
	
	// Get environment information
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);

	// Generate some random data on the root
	if(rank == 0) {
		data = new int[size * NO_DATA*2];
		srand(491);
		for(i=0;i<size*NO_DATA*2;i++) {
			data[i] = (int) ((double)rand()/RAND_MAX * 100);
			cout << setw(3) << data[i] << ", ";
		}
	}	
	
	// Scatter data to all nodes
	MPI_Scatter(data+size*NO_DATA, NO_DATA, MPI_INT, localDat, NO_DATA, MPI_INT, 0, MPI_COMM_WORLD);
	
	// Each node prints out what they have, and compute the sum
	sum = 0;
	for(i=0;i<NO_DATA;i++) {
		cout << setw(3) << localDat[i] << ", ";
		sum += localDat[i];
	}
	cout << "\n" << rank << ":" << sum << endl ;

	if(rank==0) dat1 = new int[size];
	
	// Gather
	MPI_Gather(&sum, 1, MPI_INT, dat1, 1, MPI_INT, 0, MPI_COMM_WORLD);

	// at root
	if(rank==0) {
		cout << "\nAfter gather at root: ";
		for(i=0;i<size;i++) {
			cout << setw(3) << dat1[i] << ", ";
		}	
	}
	if(rank==0) {
		delete []dat1;
		delete []data;
	}

	// Finalize
	MPI_Finalize();
	
	return 0;
}
